com.ibm.openpages.api.service

## Interface ISchedulerService

-     public interface ISchedulerService

  Provides service for OpenPages scheduling features.
  Since:
    8.2

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `ISchedJobDetail` | `createJob(ISchedJobDetail jobDetails)` Creates a new `ISchedJobDetail`
    `Id` | `createJobInstance(ISchedJobDetail jobDetail, java.lang.String triggerKey, Id processId)` Creates a new `ISchedJobInstance`.
    `void` | `deleteJobs(java.util.Set<Id> jobIds)` Soft deletes `ISchedJobDetail`s, along with any associated `ISchedJobSchedule` and `ISchedJobInstance`s.
    `void` | `deleteJobSchedules(java.util.Set<Id> jobScheduleIds)` Soft deletes `ISchedJobSchedule`s.
    `void` | `disableJobs(java.util.Set<Id> jobIds)` Updates `ISchedJobDetail`s to be disabled.
    `void` | `enableJobs(java.util.Set<Id> jobIds)` Updates `ISchedJobDetail`s to be enabled.
    `ISchedJobDetail` | `getJob(Id jobId)`
    `ISchedJobDetail` | `getJob(java.lang.String name)`
    `ISchedJobConfiguration` | `getJobConfiguration(Id jobId)`
    `SchedulerJobInstanceList` | `getJobInstances(Id jobId)`
    `SchedulerJobInstanceList` | `getJobInstances(ISchedulerJobInstanceFindOptions findOptions)`
    `SchedulerJobList` | `getJobs()`
    `SchedulerJobList` | `getJobs(IScheduleJobFindOptions findOptions)`
    `ISchedJobInstance` | `getLastManualRun(Id jobId, java.lang.String category)`
    `ISchedJobInstance` | `getLastScheduledRun(Id jobId, java.lang.String category)`
    `SchedulerScheduleList` | `getSchedules(IScheduleJobFindOptions findOptions)`
    `SchedulerScheduleList` | `getSchedules(java.util.Optional<Id> jobId)`
    `void` | `hardDeleteJobs(java.util.Set<Id> jobIds)` Hard deletes `ISchedJobDetail`s, along with any associated `ISchedJobSchedule` and `ISchedJobInstance`s.
    `Id` | `launchProcess(AbstractScheduledProcess process)` Runs the process within the Long Running Process framework.
    `void` | `runJobNow(Id jobId)` Start the job now
    `ISchedJobSchedule` | `scheduleJob(Id jobDetailId, java.lang.String cronExpression, java.util.Date startAt, java.util.Date endAt)` Creates a new `ISchedJobSchedule` instance for a `ISchedJobDetail`, given a valid new cron expression.
    `ISchedJobSchedule` | `scheduleJob(ISchedJobSchedule scheduleJob)` Persist a new `ISchedJobSchedule` instance for a `ISchedJobDetail`
    `void` | `unscheduleJob(Id jobScheduleId)` Deletes an existing `ISchedJobSchedule` instance from the job.
    `ISchedJobDetail` | `updateJob(ISchedJobDetail jobDetails)` Update an existing `ISchedJobDetail`
    `ISchedJobSchedule` | `updateJobSchedule(Id jobScheduleId, java.lang.String cronExpression, java.util.Date startAt, java.util.Date endAt)` Updates an existing `ISchedJobSchedule` instance.
    `ISchedJobSchedule` | `updateJobSchedule(ISchedJobSchedule jobSchedule)` Updates an existing `ISchedJobSchedule` instance.

- - ### Method Detail

    - #### launchProcess

          Id launchProcess(AbstractScheduledProcess process)

      Runs the process within the Long Running Process framework.
      Parameters:
        `process` - The `AbstractExternalProcess` instance to launch
      Returns:
        The `Id` of the launched process

    - #### runJobNow

          void runJobNow(Id jobId)

      Start the job now
      Parameters:
        `jobId` - The ID `ISchedJobDetail` to start

    - #### getJob

          ISchedJobDetail getJob(Id jobId)

      Parameters:
        `jobId` -
      Returns:
        A `ISchedJobDetail` by `Id`

    - #### getJob

          ISchedJobDetail getJob(java.lang.String name)

      Parameters:
        `name` -
      Returns:
        A `ISchedJobDetail` by `String`

    - #### getJobs

          SchedulerJobList getJobs()

      Returns:
        A `List` of `ISchedJobDetail`s

    - #### getJobs

          SchedulerJobList getJobs(IScheduleJobFindOptions findOptions)

      Parameters:
        `{@link` - IScheduleJobFindOptions} findOptions
      Returns:
        A `List` of `ISchedJobDetail`s

    - #### getSchedules

          SchedulerScheduleList getSchedules(java.util.Optional<Id> jobId)

      Parameters:
        `{@link` - Optional} job `Id`
      Returns:
        A `List` of `ISchedJobSchedule`s

    - #### getSchedules

          SchedulerScheduleList getSchedules(IScheduleJobFindOptions findOptions)

      Parameters:
        `{@link` - IScheduleJobFindOptions} findOptions
      Returns:
        A `List` of `ISchedJobSchedule`s

    - #### getJobInstances

          SchedulerJobInstanceList getJobInstances(Id jobId)

      Parameters:
        `jobId` - `Id`
      Returns:
        A `List` of `ISchedJobInstance`s

    - #### getJobInstances

          SchedulerJobInstanceList getJobInstances(ISchedulerJobInstanceFindOptions findOptions)

      Parameters:
        `{@link` - ISchedulerJobInstanceFindOptions} findOptions
      Returns:
        A `List` of `ISchedJobInstance`s

    - #### getLastScheduledRun

          ISchedJobInstance getLastScheduledRun(Id jobId,
                                                java.lang.String category)

      Parameters:
        `The` - job `Id`
      Returns:
        A `ISchedJobInstance`s

    - #### getLastManualRun

          ISchedJobInstance getLastManualRun(Id jobId,
                                             java.lang.String category)

      Returns:
        A `ISchedJobInstance`s

    - #### createJobInstance

          Id createJobInstance(ISchedJobDetail jobDetail,
                               java.lang.String triggerKey,
                               Id processId)

      Creates a new `ISchedJobInstance`. Not currently used.
      Parameters:
        `jobDetail` -
        `triggerKey` -
        `processId` -
      Returns:
        The id of the new `ISchedJobInstance`

    - #### createJob

          ISchedJobDetail createJob(ISchedJobDetail jobDetails)

      Creates a new `ISchedJobDetail`
      Parameters:
        `jobDetails` -
      Returns:

    - #### getJobConfiguration

          ISchedJobConfiguration getJobConfiguration(Id jobId)

      Parameters:
        `jobId` - `Id`
      Returns:
        A `List` of `SchdOPJobConfiguration_`s

    - #### updateJob

          ISchedJobDetail updateJob(ISchedJobDetail jobDetails)

      Update an existing `ISchedJobDetail`
      Parameters:
        `jobDetails` -
      Returns:

    - #### scheduleJob

          ISchedJobSchedule scheduleJob(Id jobDetailId,
                                        java.lang.String cronExpression,
                                        java.util.Date startAt,
                                        java.util.Date endAt)

      Creates a new `ISchedJobSchedule` instance for a `ISchedJobDetail`, given a valid new cron expression.
      Parameters:
        `jobDetailId` -
        `cronExpression` - Cron expression defining this job schedule
        `startAt` - The earliest time at which this job schedule should start firing
        `endAt` - The last possible time at which this schedule should fire
      Returns:

    - #### scheduleJob

          ISchedJobSchedule scheduleJob(ISchedJobSchedule scheduleJob)

      Persist a new `ISchedJobSchedule` instance for a `ISchedJobDetail`
      Parameters:
        `scheduleJob` - the new ISchedJobSchedule instance
      Returns:

    - #### updateJobSchedule

          ISchedJobSchedule updateJobSchedule(Id jobScheduleId,
                                              java.lang.String cronExpression,
                                              java.util.Date startAt,
                                              java.util.Date endAt)

      Updates an existing `ISchedJobSchedule` instance.
      Parameters:
        `jobScheduleId` -
        `cronExpression` - Cron expression defining this job schedule
        `startAt` - The earliest time at which this job schedule should start firing
        `endAt` - The last possible time at which this schedule should fire
      Returns:
        The updated `ISchedJobSchedule`

    - #### updateJobSchedule

          ISchedJobSchedule updateJobSchedule(ISchedJobSchedule jobSchedule)

      Updates an existing `ISchedJobSchedule` instance.
      Parameters:
        `jobSchedule` - the updated job schedule object
      Returns:
        The updated `ISchedJobSchedule`

    - #### deleteJobSchedules

          void deleteJobSchedules(java.util.Set<Id> jobScheduleIds)

      Soft deletes `ISchedJobSchedule`s.
      Parameters:
        `jobScheduleIds` -

    - #### unscheduleJob

          void unscheduleJob(Id jobScheduleId)

      Deletes an existing `ISchedJobSchedule` instance from the job.
      Parameters:
        `jobScheduleId` -

    - #### hardDeleteJobs

          void hardDeleteJobs(java.util.Set<Id> jobIds)

      Hard deletes `ISchedJobDetail`s, along with any associated `ISchedJobSchedule` and `ISchedJobInstance`s.
      Parameters:
        `jobIds` -

    - #### deleteJobs

          void deleteJobs(java.util.Set<Id> jobIds)

      Soft deletes `ISchedJobDetail`s, along with any associated `ISchedJobSchedule` and `ISchedJobInstance`s.
      Parameters:
        `jobIds` -

    - #### enableJobs

          void enableJobs(java.util.Set<Id> jobIds)

      Updates `ISchedJobDetail`s to be enabled.
      Parameters:
        `jobIds` -

    - #### disableJobs

          void disableJobs(java.util.Set<Id> jobIds)

      Updates `ISchedJobDetail`s to be disabled.
      Parameters:
        `jobIds` -

Licensed Materials - Property of IBM
OpenPages with Watson (PID: 5725-D51)
© Copyright IBM Corporation 2013, 2022. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.